\documentclass[8pt,a4paper]{extarticle}

\usepackage{fontspec}
\usepackage{xstring}
\usepackage{hyperref}

\begin{document}

\def\lalala{lalala}
\def\unitname{\lalala}

\edef\tagstring{\expandafter\string\unitname}

\tagstring

\StrGobbleLeft{\tagstring}{1}[\tagstring]

\tagstring

\StrGobbleLeft{\tagstring}{1}[\tagstring]

\tagstring

\hypertarget{\tagstring}{TEST}

\edef\tagstring{OHOHOH\tagstring}
\tagstring

test \hypertarget{test}{TEST}

test.\newline\hypertarget{\tagstring}{TEST}

\end{document}